datablock AudioProfile(RailgunEquipSound)
{
   filename    = "./RailgunEquip.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunDryfireSound)
{
   filename    = "./RailgunDryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunImpact1Sound)
{
   filename    = "./RailgunImpact1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunImpact2Sound)
{
   filename    = "./RailgunImpact2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunImpact3Sound)
{
   filename    = "./RailgunImpact3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunFire1Sound)
{
   filename    = "./RailgunFire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunFire2Sound)
{
   filename    = "./RailgunFire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunFire3Sound)
{
   filename    = "./RailgunFire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunFireDist1Sound)
{
   filename    = "./RailgunFireDist1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunFireDist2Sound)
{
   filename    = "./RailgunFireDist2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunFireDist3Sound)
{
   filename    = "./RailgunFireDist3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunBoltSound)
{
   filename    = "./RailgunBolt.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunChargeSound)
{
   filename    = "./RailgunCharge.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(railgunBySound)
{
   filename    = "./railgunBy.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

datablock AudioProfile(RailgunImpact1Sound)
{
   filename    = "./RailgunImpact1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunImpact2Sound)
{
   filename    = "./RailgunImpact2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RailgunImpact3Sound)
{
   filename    = "./RailgunImpact3.wav";
   description = AudioClose3d;
   preload = true;
};

// datablock AudioProfile(RailgunMagOutSound)
// {
   // filename    = "./RailgunMagOut.wav";
   // description = AudioClose3d;
   // preload = true;
// };

// datablock AudioProfile(RailgunMagInSound)
// {
   // filename    = "./RailgunMagIn.wav";
   // description = AudioClose3d;
   // preload = true;
// };

// datablock AudioProfile(RailgunBoltSound)
// {
   // filename    = "./RailgunBolt.wav";
   // description = AudioClose3d;
   // preload = true;
// };

datablock ParticleData(RailgunFireParticle)
{
    dragCoefficient      = 0;
    gravityCoefficient   = 0;
    inheritedVelFactor   = 0;
    constantAcceleration = 0.0;
    lifetimeMS           = 50;
    lifetimeVarianceMS   = 0;
    textureName          = "base/data/particles/star1";
    spinSpeed        = 9000.0;
    spinRandomMin        = -5000.0;
    spinRandomMax        = 5000.0;

    colors[0]     = "0 0.5 1.0 0.9";
    colors[1]     = "0 0.4 0.9 0.8";
    colors[2]     = "0.2 0.5 1 0.6";
    colors[3]     = "0.2 0.5 1 0.4";

    sizes[0]      = 1.75;
   sizes[1]      = 0.4;
    sizes[2]      = 0.10;
    sizes[3]      = 0.0;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 0.5;
   times[3] = 1.0;

    useInvAlpha = false;
};

datablock ParticleEmitterData(RailgunFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 64.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;

   particles = "RailgunFireParticle";
};

datablock ParticleData(RailgunTrailParticle)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 3.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 100;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "0.3 1.0 1.0 0.0";
	colors[1]	= "0.3 1.0 1.0 1.0";
	colors[2]	= "0.0 0.0 0.6 0.0";

	sizes[0]	= 0.0;
	sizes[1]	= 0.2;
	sizes[2]	= 0.12;

	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(RailgunTrailEmitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;
   ejectionVelocity = 1;
   ejectionOffset   = 0.00;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = true;

   //lifetimeMS = 5000;
   particles = RailgunTrailParticle;   
};

datablock ParticleData(RailgunExplosionParticle)
{
   textureName          = "base/data/particles/cloud";
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 150;

   colors[0]     = "0.26 0.36 0.56 1.0";
   colors[1]     = "0.26 0.36 0.56 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
};

datablock ParticleEmitterData(RailgunExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "RailgunExplosionParticle";
};

datablock ParticleData(RailgunExplosionSmoke)
{
   textureName          = "base/data/particles/cloud";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.80;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  true;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.26 0.36 0.56 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.5;
   sizes[2]      = 2.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(RailgunExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "RailgunExplosionSmoke";
};

datablock ParticleData(RailgunExplosionSparks)
{
   textureName          = "base/data/particles/star";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.30 0.40 0.60 1.0";
   colors[1]     = "0.30 0.40 0.60 1.0";
   colors[2]     = ".30 0.40 1.00 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(RailgunExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 13;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "RailgunExplosionSparks";
};
datablock ExplosionData(RecurvearrowExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(RailgunSubExplosion1)
{
   offset = 1.0;
   emitter[0] = RailgunExplosionSmokeEmitter;
   emitter[1] = RailgunExplosionSparkEmitter;
};

datablock ExplosionData(RailgunSubExplosion2)
{
   offset = 1.0;
   emitter[0] = RailgunExplosionSmokeEmitter;
   emitter[1] = RailgunExplosionSparkEmitter;
};

datablock ExplosionData(RailgunExplosion)
{
   lifeTimeMS = 1200;

   // Volume particles
   particleEmitter = RailgunExplosionEmitter;
   particleDensity = 80;
   particleRadius = 1;

   // Point emission
   emitter[0] = RailgunExplosionSmokeEmitter;
   emitter[1] = RailgunExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = RailgunSubExplosion1;
   subExplosion[1] = RailgunSubExplosion2;
   
   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 1;
   lightStartColor = "0 0.5 0.5";
   lightEndColor = "0 0 0";
      radiusDamage        = 50;
   damageRadius        = 10;
};

AddDamageType("Railgun",   '<bitmap:add-ons/Weapon_Package_Simple/ci_Railgun> %1',    '%2 <bitmap:add-ons/Weapon_Package_Simple/ci_Railgun> %1',0.2,1);
AddDamageType("RailgunHeadshot",   '<bitmap:add-ons/Weapon_Package_Simple/ci_Railgun><bitmap:add-ons/Weapon_Package_Simple/ci_headblast> %1',    '%2 <bitmap:add-ons/Weapon_Package_Simple/ci_Railgun><bitmap:add-ons/Weapon_Package_Simple/ci_headblast> %1',0.75,1);
datablock ProjectileData(RailgunProjectile : gunProjectile)
{
   directDamage        = 100;
   directDamageType    = $DamageType::Railgun;
   radiusDamageType    = $DamageType::Railgun;

   impactImpulse	     = 100;
   verticalImpulse	  = 33;
   explosion           = RailgunExplosion;
   particleEmitter     = RailgunTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 6000;
   fadeDelay           = 5500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;
   sound = railgunBySound;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = ".8 .8 0";
   uiName = "";
};
//////////
// item //
//////////
datablock ItemData(RailgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Railgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Railgun";
	iconName = "./Icon_Railgun";
	doColorShift = true;
	colorShiftColor = "0.45 0.45 0.45 1.000";

	 // Dynamic properties defined by the scripts
	image = RailgunImage;
	canDrop = true;
	
	maxAmmo = 15;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RailgunImage)
{
   // Basic Item properties
	shapeFile = "./Railgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = RailgunProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.1;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= RailgunEquipSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "DryFire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "DryFire";
	stateTransitionOnTimeout[2]     = "Ready";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = false;
	stateSound[2]					= RailgunDryfireSound;
	stateAllowImageChange[2]        = false;
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= rocketLauncherFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateEjectShell[2]       = false;

	// stateName[3] = "Bolt";
	// stateTimeoutValue[3]            = 0.95;
	// stateTransitionOnTimeout[3]     = "Ready";
	// stateSound[3]					= RailgunBoltSound;

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
};

//ads pls go

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RailgunADSImage)
{

   // Basic Item properties
   shapeFile = "./RailgunADS.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeoffset = "0 -0.35 -0.3135";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RailgunItem;
   ammo = " ";
   projectile = RailgunProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 3.3;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= RailgunChargeSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Bolt";
	stateTimeoutValue[2]            = 0.4;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= RailgunFireEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateEjectShell[2]       = true;

	stateName[3] = "Bolt";
	stateTimeoutValue[3]            = 0.9;
	stateTransitionOnTimeout[3]     = "Activate";
	stateSound[3]					= RailgunBoltSound;

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
};

function RailgunADSImage::onFire(%this,%obj,%slot)
{
	%projectile = RailgunProjectile;
	%spread = 0;
	%shellcount = 1;

	%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.spawnExplosion(QuakeHugeRecoilProjectile,"1 1 1");
	
    %random = getRandom(1,3);
    switch(%random)
    {
        case 1:
            serverplay3d("RailgunFire1Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
            serverplay2d(RailgunFireDist1Sound);
        case 2:
            serverplay3d("RailgunFire2Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
            serverplay2d(RailgunFireDist2Sound);
        case 3:
            serverplay3d("RailgunFire3Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
            serverplay2d(RailgunFireDist3Sound);
        default:
            echo("Sound error on Railgun");
    }
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function RailgunADSImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   %obj.prevDatablock = %obj.getDatablock();
   %obj.setDatablock(SlowArmor);
   // %obj.pushDatablock(SlowArmor.getID());
   %client = %obj.client;
   // %client.setControlCameraFov(40);
}

function RailgunADSImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   %obj.setDatablock(%obj.prevDatablock);
   // %obj.popDatablock(SlowArmor.getID());
   %client = %obj.client;
   // %client.setControlCameraFov(90);
}

function RailgunProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = 100;
   %damage = %directDamage;

   %sobj = %obj.sourceObject;
   if(%sobj.getType() & $TypeMasks::PlayerObjectType)
   {
      if(isObject(%sobj.client))
		%obj.sourceObject.client.centerPrint("<bitmap:add-ons/weapon_package_simple/hitmarker.png>", 0.4);
		%obj.sourceObject.client.play2D(hitMarkerSound);
   }
   
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 10;
         %damageType = $DamageType::RailgunHeadshot;
         
         if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         {
            serverplay3d(critFireSound,%sobj.getHackPosition());
            if(isObject(%sobj.client))
               %sobj.client.play2d(hitMarkerCritSound);
				%obj.sourceObject.client.centerPrint("<bitmap:add-ons/weapon_package_simple/hitmarkercrit.png>", 0.4);
         }
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}

package Railgun
{
  	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getMountedImage(0) $= RailgunImage.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(RailgunADSImage,0);
		}     
		
		else if(%player.getMountedImage(0) $= RailgunADSImage.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(RailgunImage,0);
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}

	function servercmdDropTool(%client,%slot)
	{
		if(%client.player.getMountedImage(0) $= RailgunADSImage.getID())
		{
		  %client.player.unmountImage(0);
		}
		return Parent::servercmdDropTool(%client,%slot);
	}
};	
ActivatePackage(Railgun);

function RailgunProjectile::onExplode(%this,%obj)
{
  %rnd = getRandom(1,3);
  if(%rnd == 1) serverPlay3D(RailgunImpact1Sound,%obj.getTransform());
  if(%rnd == 2) serverPlay3D(RailgunImpact2Sound,%obj.getTransform());
  if(%rnd == 3) serverPlay3D(RailgunImpact3Sound,%obj.getTransform());
  parent::onExplode(%this,%obj);
}