datablock AudioProfile(TavorEquipSound)
{
   filename    = "./TavorEquip.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TavorFire1Sound)
{
   filename    = "./TavorFire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TavorFire2Sound)
{
   filename    = "./TavorFire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TavorFire3Sound)
{
   filename    = "./TavorFire3.wav";
   description = AudioClose3d;
   preload = true;
};

// datablock ParticleData(TavorFireParticle)
// {
    // dragCoefficient      = 0;
    // gravityCoefficient   = 0;
    // inheritedVelFactor   = 0;
    // constantAcceleration = 0.0;
    // lifetimeMS           = 50;
    // lifetimeVarianceMS   = 0;
    // textureName          = "base/data/particles/star1";
    // spinSpeed        = 9000.0;
    // spinRandomMin        = -5000.0;
    // spinRandomMax        = 5000.0;

    // colors[0]     = "1.0 0.5 0 0.9";
    // colors[1]     = "0.9 0.4 0 0.8";
    // colors[2]     = "1 0.5 0.2 0.6";
    // colors[3]     = "1 0.5 0.2 0.4";

    // sizes[0]      = 1.75;
   // sizes[1]      = 0.4;
    // sizes[2]      = 0.10;
    // sizes[3]      = 0.0;

   // times[0] = 0.0;
   // times[1] = 0.1;
   // times[2] = 0.5;
   // times[3] = 1.0;

    // useInvAlpha = false;
// };
// datablock ParticleEmitterData(TavorFireEmitter)
// {
   // ejectionPeriodMS = 1;
   // periodVarianceMS = 0;
   // ejectionVelocity = 64.0;
   // velocityVariance = 0.0;
   // ejectionOffset   = 0.0;
   // thetaMin         = 0;
   // thetaMax         = 1;
   // phiReferenceVel  = 0;
   // phiVariance      = 360;
   // overrideAdvance = false;

   // particles = "TavorFireParticle";
// };

// datablock ParticleData(TavorSmokeParticle)
// {
    // dragCoefficient      = 3;
    // gravityCoefficient   = 0;
    // inheritedVelFactor   = 0;
    // constantAcceleration = 0.0;
    // lifetimeMS           = 100;
    // lifetimeVarianceMS   = 0;
    // textureName          = "base/data/particles/cloud";
    // spinSpeed        = 9000.0;
    // spinRandomMin        = -5000.0;
    // spinRandomMax        = 5000.0;

    // colors[0]     = "0.6 0.6 0.6 0.0";
    // colors[1]     = "0.7 0.7 0.7 0.3";
    // colors[2]     = "1 1 1 0.2";
    // colors[3]     = "1 1 1 0";

    // sizes[0]      = 0.0;
   // sizes[1]      = 0.4;
    // sizes[2]      = 0.10;
    // sizes[3]      = 0.05;

   // times[0] = 0.0;
   // times[1] = 0.1;
   // times[2] = 0.5;
   // times[3] = 1.0;

    // useInvAlpha = false;
// };
// datablock ParticleEmitterData(TavorSmokeEmitter)
// {
   // ejectionPeriodMS = 1;
   // periodVarianceMS = 0;
   // ejectionVelocity = 32.0;
   // velocityVariance = 0.0;
   // ejectionOffset   = 0.0;
   // thetaMin         = 0;
   // thetaMax         = 1;
   // phiReferenceVel  = 0;
   // phiVariance      = 360;
   // overrideAdvance = false;

   // particles = "TavorSmokeParticle";
// };

// datablock ParticleData(TavorTrailParticle)
// {
	// dragCoefficient		= 3.0;
	// windCoefficient		= 0.0;
	// gravityCoefficient	= 0.0;
	// inheritedVelFactor	= 0.0;
	// constantAcceleration	= 0.0;
	// lifetimeMS		= 80;
	// lifetimeVarianceMS	= 0;
	// spinSpeed		= 10.0;
	// spinRandomMin		= -50.0;
	// spinRandomMax		= 50.0;
	// useInvAlpha		= false;
	// animateTexture		= false;
	// //framesPerSec		= 1;

	// textureName		= "base/data/particles/cloud";
	// //animTexName		= "~/data/particles/dot";

	// // Interpolation variables
	// colors[0]	= "1 1 0 0.1";
	// colors[1]	= "1 1 0.4 0.08";
	// colors[2]	= "0.7 0.7 0.7 0";
	// sizes[0]	= 0.3;
	// sizes[1]	= 0.15;
	// sizes[2]	= 0.0;
	// times[0]	= 0.0;
	// times[1]	= 0.1;
	// times[2]	= 1.0;
// };
// datablock ParticleEmitterData(TavorTrailEmitter)
// {
   // ejectionPeriodMS = 1;
   // periodVarianceMS = 0;
   // ejectionVelocity = 0; //0.25;
   // velocityVariance = 0; //0.10;
   // ejectionOffset = 0;
   // thetaMin         = 0.0;
   // thetaMax         = 90.0;  

   // particles = TavorTrailParticle;
// };

AddDamageType("Tavor",   '<bitmap:add-ons/Weapon_Package_Simple/ci_Tavor> %1',    '%2 <bitmap:add-ons/Weapon_Package_Simple/ci_Tavor> %1',0.2,1);
AddDamageType("TavorHeadshot",   '<bitmap:add-ons/Weapon_Package_Simple/ci_Tavor><bitmap:add-ons/Weapon_Package_Simple/ci_headshot> %1',    '%2 <bitmap:add-ons/Weapon_Package_Simple/ci_Tavor><bitmap:add-ons/Weapon_Package_Simple/ci_headshot> %1',0.75,1);
datablock ProjectileData(TavorProjectile : gunProjectile)
{
   directDamage        = 15;
   directDamageType    = $DamageType::Tavor;
   radiusDamageType    = $DamageType::Tavor;

   impactImpulse	     = 200;
   verticalImpulse	  = 60;
   explosion           = gunExplosion;
   particleEmitter     = ARTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 190;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 6000;
   fadeDelay           = 5500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.1;
   sound = bulletBySound;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = ".8 .8 0";
   uiName = "";
};
//////////
// item //
//////////
datablock ItemData(TavorItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./tavor.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Assault Rifle B";
	iconName = "./Icon_Tavor";
	doColorShift = true;
	colorShiftColor = "0.45 0.45 0.45 1.000";

	// Dynamic properties defined by the scripts
	image = TavorImage;
	canDrop = true;
	
	maxAmmo = 22;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TavorImage)
{
   // Basic Item properties
	shapeFile = "./tavor.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = TavorProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.85;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= TavorEquipSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.065;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= ARFireEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= ARSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.03;
	stateTransitionOnTimeout[3]     = "Ready";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
};

function TavorImage::onFire(%this,%obj,%slot)
{
	%projectile = TavorProjectile;
	%spread = 0.0025;
	%shellcount = 1;

	%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.spawnExplosion(QuakeRecoilProjectile,"1 1 1");
	
    %random = getRandom(1,3);
    switch(%random)
    {
        case 1:
            serverplay3d("TavorFire1Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
        case 2:
            serverplay3d("TavorFire2Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
        case 3:
            serverplay3d("TavorFire3Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
        default:
            echo("Sound error on Assault Rifle");
    }
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

//ads pls go

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TavorADSImage)
{

   // Basic Item properties
   shapeFile = "./tavorads.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeoffset = "0 0.8 -0.322";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TavorItem;
   ammo = " ";
   projectile = TavorProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= ARADSinSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.065;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= ARFireEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= ARSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.03;
	stateTransitionOnTimeout[3]     = "Ready";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
};

function TavorADSImage::onFire(%this,%obj,%slot)
{
	%projectile = TavorProjectile;
	%spread = 0.0015;
	%shellcount = 1;
	%obj.spawnExplosion(QuakeLittleRecoilProjectile,"1 1 1");

	%obj.playThread(2, plant);
	%shellcount = 1;
	
    %random = getRandom(1,3);
    switch(%random)
    {
        case 1:
            serverplay3d("TavorFire1Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
        case 2:
            serverplay3d("TavorFire2Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
        case 3:
            serverplay3d("TavorFire3Sound", %obj.getHackPosition() SPC "0 0 1 0"); 
        default:
            echo("Sound error on Assault Rifle B");
    }
            		
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function TavorADSImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   %obj.prevDatablock = %obj.getDatablock();
   %obj.setDatablock(SlowArmor);
   // %obj.pushDatablock(SlowArmor.getID());
   %client = %obj.client;
   // %client.setControlCameraFov(45);
}

function TavorADSImage::onUnMount(%this,%obj,%slot)
{
   Parent::onUnMount(%this,%obj,%slot);
   if(!isObject(%obj.prevDatablock)) %obj.prevDatablock = playerStandardArmor;
   %obj.setDatablock(%obj.prevDatablock);
   // %obj.popDatablock(SlowArmor.getID());
   %client = %obj.client;
   // %client.setControlCameraFov(90);
}

function TavorProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = 15;
   %damage = %directDamage;

   %sobj = %obj.sourceObject;
   if(%sobj.getType() & $TypeMasks::PlayerObjectType)
   {
      if(isObject(%sobj.client))
		%obj.sourceObject.client.centerPrint("<bitmap:add-ons/weapon_package_simple/hitmarker.png>", 0.4);
		%obj.sourceObject.client.play2D(hitMarkerSound);
   }
   
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 2;
         %damageType = $DamageType::TavorHeadshot;
         
         if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         {
            serverplay3d(critFireSound,%sobj.getHackPosition());
            if(isObject(%sobj.client))
               %sobj.client.play2d(hitMarkerCritSound);
				%obj.sourceObject.client.centerPrint("<bitmap:add-ons/weapon_package_simple/hitmarkercrit.png>", 0.4);
         }
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}

package Tavor
{
  	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getMountedImage(0) $= TavorImage.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(TavorADSImage,0);
		}     
		
		else if(%player.getMountedImage(0) $= TavorADSImage.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(TavorImage,0);
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}

	function servercmdDropTool(%client,%slot)
	{
		if(%client.player.getMountedImage(0) $= TavorADSImage.getID())
		{
		  %client.player.unmountImage(0);
		}
		return Parent::servercmdDropTool(%client,%slot);
	}
};	
ActivatePackage(Tavor);

function TavorProjectile::onExplode(%this,%obj)
{
  %rnd = getRandom(1,3);
  if(%rnd == 1) serverPlay3D(bulletImpact1Sound,%obj.getTransform());
  if(%rnd == 2) serverPlay3D(bulletImpact2Sound,%obj.getTransform());
  if(%rnd == 3) serverPlay3D(bulletImpact3Sound,%obj.getTransform());
  parent::onExplode(%this,%obj);
}