datablock AudioProfile(theHypeSound)
{
   filename    = "./theHype.wav";
   description = AudioClose3d;
   preload = true;
};

//hitmarker effects
datablock AudioProfile(HitmarkerSound)
{
   filename    = "./hitMarkerSound.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(HitmarkerCritSound)
{
   filename    = "./hitMarkerCritSound.wav";
   description = AudioClose3d;
   preload = true;
};

//fancy bullet sounds from gravity cat
datablock AudioProfile(bulletImpact1Sound)
{
   filename    = "./bulletImpact1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(bulletImpact2Sound)
{
   filename    = "./bulletImpact2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(bulletImpact3Sound)
{
   filename    = "./bulletImpact3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(bulletBySound)
{
   filename    = "./bulletBy.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

//bushido's recoil explosions
datablock ExplosionData(QuakeLittleRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "1 1 1";
  camShakeAmp = "0.1 0.3 0.2";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(QuakeLittleRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= QuakeLittleRecoilExplosion;

};

datablock ExplosionData(QuakeRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "2 2 2";
  camShakeAmp = "0.3 0.5 0.4";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(QuakeRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= QuakeRecoilExplosion;

};

datablock ExplosionData(QuakeBigRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "3 3 3";
  camShakeAmp = "0.6 0.8 0.7";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(QuakeBigRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= QuakeBigRecoilExplosion;

};

datablock ExplosionData(QuakeHugeRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1.1 1.3 1.2";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(QuakeHugeRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= QuakeHugeRecoilExplosion;

};

// slow player, thrown together using the left4block camera (intended for use with that) and the slow player out of T+T

datablock PlayerData(SlowArmor : PlayerStandardArmor)
{
   runForce = 25 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 4;
   maxBackwardSpeed = 4;
   maxSideSpeed = 4;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 9 * 90; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "";
	showEnergyBar = false;
	firstpersononly = 1;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
   
   isSurvivor = 1;
};

exec("./Support_AltDatablock.cs");
exec("./Weapon_AR.cs");
exec("./Weapon_P90.cs");
exec("./Weapon_Pistol.cs");
exec("./Weapon_Railgun.cs");
exec("./Weapon_Shotgun.cs");
exec("./Weapon_SMG.cs");
exec("./Weapon_Sniper.cs");
exec("./Weapon_Tavor.cs");